SystemOrganization addCategory: #Coral!
SystemOrganization addCategory: #'Coral-Tests'!

!MacProcess methodsFor: '*coral' stamp: 'ms 10/5/2006 15:01'!
newLineInConsole
	
	self isUnix 
			ifTrue:[^String lf] 
			ifFalse:[^String cr]! !

TestCase subclass: #CoralClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Tests'!

!CoralClassTest methodsFor: 'setup' stamp: 'StephaneDucasse 12/8/2009 17:54'!
setUp

	" does not work ;(
	
	Smalltalk at: #ColorPoint ifPresent: [:each | each removeFromSystem ]
	
	"! !

!CoralClassTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/5/2009 19:49'!
testClassDefWithOneIV
	"self debug: #testClassDefWithOneIV"
	
	| coloredPointClass |
	coloredPointClass := Point < #ColoredPoint 
							iv: 'color' .
	self assert: coloredPointClass superclass = Point.
	self deny: coloredPointClass instVarNames isEmpty.
	self assert: coloredPointClass instVarNames = #('color')! !

!CoralClassTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/5/2009 19:55'!
testClassDefWithOneSharedIV
	"self debug: #testClassDefWithOneSharedIV"
	
	| coloredPointClass |
	coloredPointClass := Point < #ColoredPoint 
							shared: 'DefaultColor'.
	self assert: coloredPointClass superclass = Point.
	self assert: coloredPointClass instVarNames isEmpty.
	self assert: (coloredPointClass classVarNames  includes: 'DefaultColor')! !

!CoralClassTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/5/2009 19:50'!
testClassDefWithSeveralIV
	"self debug: #testClassDefWithSeveralIV"
	
	| coloredPointClass |
	coloredPointClass := Point < #ColoredPoint 
							iv: 'color z'.
	self assert: coloredPointClass superclass = Point.
	self deny: coloredPointClass instVarNames isEmpty.
	self assert: (coloredPointClass instVarNames includes: 'color').
	self assert: (coloredPointClass instVarNames includes: 'z').! !

!CoralClassTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/5/2009 19:50'!
testClassDefWithSeveralIVWithSeparateDef
	"self debug: #testClassDefWithSeveralIVWithSeparateDef"
	
	| coloredPointClass |
	coloredPointClass := Point < #ColoredPoint 
							iv: 'color';
							iv: 'z'.
	self assert: coloredPointClass superclass = Point.
	self deny: coloredPointClass instVarNames isEmpty.
	self assert: (coloredPointClass instVarNames includes: 'color').
	self assert: (coloredPointClass instVarNames includes: 'z').! !

!CoralClassTest methodsFor: 'tests-arguments' stamp: 'AdrienBarreau 10/13/2010 13:20'!
testExtractAllKinds
	| args extract keys |
	
	args := #('ArgWithoutMinus1' '-ArgWithMinus1' 'ArgWithoutMinus2' 'ArgWithoutMinus3' '-ArgWithMinus2').
	extract := SmalltalkImage current extractMinusParametersFrom: args.
	keys := extract keys sort.
	
	self assert: extract isDictionary.
	self assert: extract size = 3.
	self assert: ((keys at:1) = #*).
	self assert: ((keys at:2) = #ArgWithMinus1).
	self assert: ((keys at:3) = #ArgWithMinus2).
	self assert: ((extract at:#*) = (Array with: 'ArgWithoutMinus1')).
	self assert: ((extract at:#ArgWithMinus1) = #('ArgWithoutMinus2' 'ArgWithoutMinus3')).
	self assert: ((extract at: #ArgWithMinus2) isEmpty)
	! !

!CoralClassTest methodsFor: 'tests-arguments' stamp: 'AdrienBarreau 10/13/2010 13:09'!
testExtractEmpty
	| args extract |
	
	args := #().
	extract := SmalltalkImage current extractMinusParametersFrom: args.
	
	self assert: extract class = Dictionary.
	self assert: extract isEmpty.
	! !

!CoralClassTest methodsFor: 'tests-arguments' stamp: 'AdrienBarreau 10/13/2010 13:08'!
testExtractNil
	| args extract |
	
	args := nil.
	extract := SmalltalkImage current extractMinusParametersFrom: args.
	
	self assert: extract class = Dictionary.
	self assert: extract isEmpty.
	! !

!CoralClassTest methodsFor: 'tests-arguments' stamp: 'AdrienBarreau 10/13/2010 13:18'!
testExtractOneArgNoMinus
	| args extract |
	
	args := #('ArgNoMinus').
	extract := SmalltalkImage current extractMinusParametersFrom: args.
	
	self assert: extract isDictionary.
	self assert: extract size = 1.
	self assert: ((extract keys at:1) = #*).
	self assert: ((extract at:#*) = args)
	! !

!CoralClassTest methodsFor: 'tests-arguments' stamp: 'AdrienBarreau 10/13/2010 13:20'!
testExtractOneArgWithMinus
	| args extract |
	
	args := #('-ArgWithMinus').
	extract := SmalltalkImage current extractMinusParametersFrom: args.
	
	self assert: extract isDictionary.
	self assert: extract size = 1.
	self assert: ((extract keys at:1) = #ArgWithMinus).
	self assert: ((extract at:#ArgWithMinus) isEmpty)
	! !

!CoralClassTest methodsFor: 'tests-arguments' stamp: 'AdrienBarreau 10/13/2010 13:25'!
testExtractOneArgWithMinusThenArgsWithout
	| args extract |
	
	args := #('-ArgWithMinus' 'ArgWithoutMinus1' 'ArgWithoutMinus2' ).
	extract := SmalltalkImage current extractMinusParametersFrom: args.
	
	self assert: extract isDictionary.
	self assert: extract size = 1.
	self assert: ((extract keys at:1) = #ArgWithMinus).
	self assert: ((extract at:#ArgWithMinus) = #('ArgWithoutMinus1' 'ArgWithoutMinus2' ))
	! !

!CoralClassTest methodsFor: 'tests-arguments' stamp: 'AdrienBarreau 10/13/2010 15:26'!
testExtractTwoArgsWithAndWithoutMinus
	| args extract keys |
	
	args := #('ArgWithoutMinus' '-ArgWithMinus').
	extract := SmalltalkImage current extractMinusParametersFrom: args.
	keys := extract keys sort.
	
	self assert: extract isDictionary.
	self assert: extract size = 2.
	self assert: ((keys at:1) = #*).
	self assert: ((keys at:2) = #ArgWithMinus).
	self assert: ((extract at:#*) = (Array with: 'ArgWithoutMinus')).
	self assert: ((extract at:#ArgWithMinus) isEmpty)
	! !

!CoralClassTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/5/2009 19:42'!
testSimpleClassDef
	"self debug: #testSimpleClassDef"
	
	| coloredPointClass |
	coloredPointClass := Point < #ColoredPoint.
	self assert: coloredPointClass superclass = Point.
	self assert: coloredPointClass instVarNames isEmpty! !

!CoralClassTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/5/2009 21:37'!
testSimpleClassDefWithPackage
	"self debug: #testSimpleClassDefWithPackage"
	
	| coloredPointClass |
	coloredPointClass := Point < #ColoredPoint
							package: #Box.
	self assert: coloredPointClass superclass = Point.
	self assert: coloredPointClass package = #Box.
	self assert: coloredPointClass category = #Box.
	! !

!OS2Process methodsFor: '*coral' stamp: 'ms 10/5/2006 14:14'!
newLineInConsole
	
	^String cr, String lf! !

PPCompositeParser subclass: #PPCoralGrammar
	instanceVariableNames: 'block method program methodHeader methodBody bang smalltalk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!PPCoralGrammar class methodsFor: 'accessing' stamp: 'lr 12/7/2009 13:53'!
ignoredNames
	^ super ignoredNames , #(smalltalk)! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'lr 11/29/2009 10:34'!
bang
	^ '#!!' asParser , (#newline asParser negate) star! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'lr 11/28/2009 18:25'!
block
	^ self smalltalk block! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'sd 11/8/2010 10:07'!
method

	^ methodHeader , methodBody! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'sd 11/8/2010 09:50'!
methodBody
	^ $[ asParser token trim , self smalltalk	 pragmas , self smalltalk temporaries , self smalltalk pragmas , self smalltalk statements , $] asParser token trim! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'sd 11/8/2010 10:20'!
methodHeader

	^ self smalltalk identifierToken , 'class' asParser token trim optional , '>>' asParser token trim , self smalltalk methodDeclaration! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'lr 11/28/2009 18:38'!
program
	^ bang optional , (block / method) star! !

!PPCoralGrammar methodsFor: 'composition' stamp: 'lr 11/28/2009 18:48'!
smalltalk
	^ smalltalk ifNil: [ smalltalk := PPSmalltalkGrammar new ]! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'lr 11/28/2009 18:16'!
start
	^ program end! !

PPCoralGrammar subclass: #PPCoralParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!PPCoralParser class methodsFor: 'as yet unclassified' stamp: 'TestRunner 12/7/2009 16:09'!
todo

	"use last version of OSProcess"
	"merge PetitCoral and Coral"
	"Create a configuration to load everything in one click"
	
	"DONE After"
	"for Method
	aClass compile: aMethodNode formattedCode

for Block
	Compiler evaluate: aSequenceNode formattedCode"
	
	"or formattedString"! !

!PPCoralParser methodsFor: 'productions' stamp: 'TestRunner 12/7/2009 16:54'!
block
	^ super block ==> [ :nodes |
		"waiting for the new compiler. For the moment we ask the old compiler to recompile everything"
		Compiler evaluate:  nodes body formattedCode	
		]
	
! !

!PPCoralParser methodsFor: 'productions' stamp: 'sd 11/8/2010 10:21'!
method

	^ super method ==> [ :nodes |
			"waiting for the new compiler. For the moment we ask the old compiler to recompile everything"
					nodes first key compile:
						(nodes first value
								pragmas: nodes second second , nodes second fourth;
								body: (self smalltalk 
												build: nodes second third
												sequence: nodes second fifth);
										yourself) formattedCode ]! !

!PPCoralParser methodsFor: 'productions' stamp: 'TestRunner 12/9/2009 21:32'!
methodHeader
	^ super methodHeader map: [ :className :metaclass :separator :methodDecl |
		| class |
		class := Smalltalk classNamed: className value.
		metaclass isNil ifFalse: [ class := class class ].
		class -> methodDecl ]! !

!PPCoralParser methodsFor: 'productions' stamp: 'TestRunner 12/7/2009 16:20'!
program
	^ super program ==> #second! !

!PPCoralParser methodsFor: 'composition' stamp: 'lr 12/7/2009 13:52'!
smalltalk
	^ smalltalk ifNil: [ smalltalk := PPSmalltalkParser new ]! !

PPAbstractParseTest subclass: #CLIParsingTest
	instanceVariableNames: 'flag option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Tests'!

!CLIParsingTest class methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/7/2011 13:26'!
packageNamesUnderTest
	^ #('Coral')! !

!CLIParsingTest methodsFor: 'fixtures' stamp: 'DamienPollet 8/4/2011 15:52'!
any
	^ CLIParameter any name: 'something'! !

!CLIParsingTest methodsFor: 'fixtures' stamp: 'DamienPollet 8/4/2011 17:06'!
anyOf
	^ (CLIParameter anyOf: #(left right up down))
		name: 'direction'! !

!CLIParsingTest methodsFor: 'fixtures' stamp: 'DamienPollet 8/4/2011 17:41'!
optionBoth
	^ CLIOption new
		short: $b;
		long: 'both'! !

!CLIParsingTest methodsFor: 'fixtures' stamp: 'DamienPollet 8/4/2011 17:41'!
optionLong
	^ CLIOption new
		long: 'long'! !

!CLIParsingTest methodsFor: 'fixtures' stamp: 'DamienPollet 8/4/2011 17:38'!
optionShort
	^ CLIOption new
		short: $s! !

!CLIParsingTest methodsFor: 'running' stamp: 'DamienPollet 8/4/2011 15:41'!
setUp
	super setUp.
	
	"flag := CommandLineFlag new
		description: 'Play the xylophone';
		name: 'xylophone';
		short: $x.
	option := CommandLineOption new
		description: 'Miraculously guess what to do with the argument';
		name: 'oops';
		short: $o;
		argumentParser: #word asParser plus"! !

!CLIParsingTest methodsFor: 'tests-parameters' stamp: 'DamienPollet 8/4/2011 16:15'!
testAny
	self assert: self any parse: #('abc') to: 'abc'.
	self assert: self any parse: #('123') to: '123'.
	self assert: self any parse: #('x & ;') to: 'x & ;'.
	self assert: self any parse: #('') to: ''.
	
	self assert: self any parse: #('123' 'abc') end: 1.
	
	self assert: self any fail: #().
! !

!CLIParsingTest methodsFor: 'tests-fixme' stamp: 'DamienPollet 8/4/2011 16:49'!
testAnyDashes
	<expectedFailure>
	"There is an ambiguity: should we accept an argument even if it looks like an option flag?"
	
	self assert: self any fail: #('-x').
	self assert: self any fail: #('--foo').
	
	self assert: self any plus parse: #('foo' '-x') to: #('foo') end: 1.
	self assert: self any star fail: #('--foo' '-x') end: 0.
		
	self assert: self any star parse: #('--foo' '-x') to: #() end: 0.! !

!CLIParsingTest methodsFor: 'tests-parameters' stamp: 'DamienPollet 8/4/2011 17:29'!
testAnyOf
	self assert: self anyOf parse: #('left') to: 'left'.
	self assert: self anyOf parse: #('up') to: 'up'.
	
	self assert: self anyOf parse: #('down' 'right') to: 'down' end: 1.
	
	self assert: self anyOf fail: #('center').
	self assert: self anyOf fail: #('upper')! !

!CLIParsingTest methodsFor: 'tests-parameters' stamp: 'DamienPollet 8/4/2011 17:25'!
testAnyOfPlus
	self assert: self anyOf plus parse: #('down' 'right' 'center' 'left') to: #('down' 'right') end: 2.
! !

!CLIParsingTest methodsFor: 'tests-parameters' stamp: 'DamienPollet 8/4/2011 16:35'!
testAnyOptional
	self assert: self any optional parse: #('abc') to: 'abc'.
	self assert: self any optional parse: #('123') to: '123'.
	self assert: self any optional parse: #('x & ;') to: 'x & ;'.
	self assert: self any optional parse: #('') to: ''.
	
	self assert: self any optional parse: #('123' 'abc') end: 1.
	
	self assert: self any optional parse: #() to: nil.
! !

!CLIParsingTest methodsFor: 'tests-parameters' stamp: 'DamienPollet 8/4/2011 16:44'!
testAnyPlus
	self assert: self any plus parse: #('abc') to: #('abc').
	self assert: self any plus parse: #('123') to: #('123').
	self assert: self any plus parse: #('x & ;') to: #('x & ;').
	self assert: self any plus parse: #('') to: #('').
	
	self assert: self any plus parse: #('123' 'abc' 'jk6') to: #('123' 'abc' 'jk6').
	
	self assert: self any plus fail: #().
! !

!CLIParsingTest methodsFor: 'tests-parameters' stamp: 'DamienPollet 8/4/2011 16:45'!
testAnyStar
	self assert: self any star parse: #('abc') to: #('abc').
	self assert: self any star parse: #('123') to: #('123').
	self assert: self any star parse: #('x & ;') to: #('x & ;').
	self assert: self any star parse: #('') to: #('').
	
	self assert: self any star parse: #('123' 'abc' 'jk6') to: #('123' 'abc' 'jk6').
	
	self assert: self any star parse: #() to: #().
! !

!CLIParsingTest methodsFor: 'tests-options' stamp: 'DamienPollet 8/4/2011 18:16'!
testOptionLong
	self assert: self optionLong parse: #('--long') to: '--long'.
	self assert: self optionLong end fail: #('--long-long').! !

!CLIParsingTest methodsFor: 'tests-options' stamp: 'DamienPollet 8/4/2011 17:41'!
testOptionNames
	self assert: self optionShort name = '-s'.
	self assert: self optionLong name = '--long'.
	self assert: self optionBoth name = '-b/--both'! !

!CLIParsingTest methodsFor: 'tests-options' stamp: 'DamienPollet 8/4/2011 18:19'!
testOptionShort
	self assert: self optionShort shortForm = '-s'.
	self assert: self optionShort longForm = nil.
	
	self assert: self optionShort parse: #('-s') to: '-s'.
	self assert: self optionShort fail: #('--s').
	self assert: self optionShort end fail: #('-ss').! !

!CLIParsingTest methodsFor: 'tests-parameters' stamp: 'DamienPollet 8/4/2011 17:31'!
testParameterNames
	self assert: self any name = 'something'.
	self assert: self anyOf name = 'direction'.! !

!Class methodsFor: '*coral' stamp: 'StephaneDucasse 12/8/2009 17:46'!
< aSubclassSymbol

	^ self subclass: aSubclassSymbol ! !

!Class methodsFor: '*coral' stamp: 'LucFabresse 1/31/2011 13:24'!
iv: aStringOfaSingleOrMultipleIV

	^ self addInstVarNamed: aStringOfaSingleOrMultipleIV! !

!Class methodsFor: '*coral' stamp: 'StephaneDucasse 12/8/2009 17:46'!
package

	^ self category! !

!Class methodsFor: '*coral' stamp: 'StephaneDucasse 12/8/2009 17:46'!
package: aString

	self category: aString! !

!Class methodsFor: '*coral' stamp: 'LucFabresse 1/31/2011 13:25'!
shared: aStringOfaSingleOrMultipleClassVar

	^ self addClassVarNamed: aStringOfaSingleOrMultipleClassVar! !

PPParser subclass: #CLITerm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

CLITerm subclass: #CLICommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!CLICommand methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/4/2011 09:39'!
aliases
	"Synonyms or shortened versions of the main name"
	
	^ self shouldBeImplemented ! !

!CLICommand methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/4/2011 09:49'!
description
	"Verbose description of the command itself"
	
	^ self shouldBeImplemented! !

!CLICommand methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/4/2011 10:08'!
manual
	"Free-form detailed documentation, comes after summary, synopsis, description, and options"
	
	^ self shouldBeImplemented! !

!CLICommand methodsFor: 'accessing' stamp: 'DamienPollet 8/4/2011 09:38'!
name
	"Canonic name"
	
	^ self shouldBeImplemented! !

!CLICommand methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/4/2011 09:41'!
options
	"Optional arguments and flags"

	^ self shouldBeImplemented! !

!CLICommand methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/4/2011 09:41'!
parameters
	"Positional parameters"
	
	^ self shouldBeImplemented! !

!CLICommand methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/4/2011 09:45'!
parser
	"A parser that will recognize this command at the beginning of a stream of arguments"
	
	^ self shouldBeImplemented! !

!CLICommand methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/4/2011 09:46'!
subCommands
	"Sub-commands, coming after or in place of any positional parameters"
	
	^ self shouldBeImplemented! !

!CLICommand methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/4/2011 09:48'!
summary
	"One-line description of what this command is for"
	
	^ self shouldBeImplemented! !

!CLICommand methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/4/2011 09:48'!
synopsis
	"Typical patterns of invocation"
	
	^ self shouldBeImplemented! !

CLITerm subclass: #CLIOption
	instanceVariableNames: 'short long parser parameter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!CLIOption methodsFor: 'accessing' stamp: 'DamienPollet 8/4/2011 10:05'!
description
	^ self shouldBeImplemented! !

!CLIOption methodsFor: 'initialization' stamp: 'DamienPollet 8/4/2011 14:41'!
long: aString
	aString isEmpty ifTrue: [ CLIInvalidSpec signal: 'Long form cannot be ''--''' ].
	long := aString! !

!CLIOption methodsFor: 'accessing' stamp: 'DamienPollet 8/4/2011 14:44'!
longForm
	"Verbose, double-dash form"
	^ long ifNotNil: [ '--' , long ]! !

!CLIOption methodsFor: 'accessing' stamp: 'DamienPollet 8/4/2011 17:49'!
name
	| forms |
	forms := OrderedCollection new: 2.
	self shortForm ifNotNilDo: [ :it | forms add: it ].
	self longForm ifNotNilDo: [ :it | forms add: it ].
	^ $/ join: forms! !

!CLIOption methodsFor: 'accessing' stamp: 'DamienPollet 8/4/2011 15:04'!
parameter
	^ parameter! !

!CLIOption methodsFor: 'initialization' stamp: 'DamienPollet 8/4/2011 15:04'!
parameter: aParameter
	parameter := aParameter! !

!CLIOption methodsFor: 'accessing' stamp: 'DamienPollet 8/7/2011 02:33'!
parser
	^ parser ifNil: [ | choices |
		choices := OrderedCollection new: 2.
		self shortForm ifNotNilDo: [ :it | choices add: it asParser ].
		self longForm ifNotNilDo: [ :it | choices add: it asParser ].
		parser := PPPredicateObjectParser
					matching: (PPChoiceParser withAll: choices) token end
					message: 'Option ' , self name , ' expected'.
		parameter ifNotNil: [ parser := parser , parameter ].
		parser ]! !

!CLIOption methodsFor: 'initialization' stamp: 'DamienPollet 8/4/2011 14:38'!
short: aCharacter
	aCharacter = $- ifTrue: [ CLIInvalidSpec signal: 'Short form option cannot be --' ].
	short := aCharacter! !

!CLIOption methodsFor: 'accessing' stamp: 'DamienPollet 8/4/2011 14:44'!
shortForm
	"Terse, clusterable form (dash-character)"
	^ short ifNotNil: [ '-' copyWith: short ]! !

CLITerm subclass: #CLIParameter
	instanceVariableNames: 'name parser isOptional isMultiple'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!CLIParameter class methodsFor: 'factory' stamp: 'DamienPollet 8/4/2011 12:08'!
any
	^ self new
		setParser: #any asParser;
		name: 'param'
		! !

!CLIParameter class methodsFor: 'factory' stamp: 'DamienPollet 8/4/2011 13:07'!
anyOf: anArray
	^ self new
		setParser: (PPPredicateObjectParser anyOf: anArray);
		name: ('|' join: anArray)! !

!CLIParameter class methodsFor: 'factory' stamp: 'DamienPollet 8/4/2011 12:49'!
boolean
	^ self new
		setParser: (PPPredicateObjectParser anyOf: #('true' 'TRUE' 'false' 'FALSE' 'yes' 'YES' 'no' 'NO'));
		name: 'bool'
		! !

!CLIParameter class methodsFor: 'factory' stamp: 'DamienPollet 8/4/2011 13:04'!
keyword: aString
	^ self new
		setParser: (PPPredicateObjectParser expect: aString message: aString , ' expected');
		name: aString
		! !

!CLIParameter class methodsFor: 'factory' stamp: 'DamienPollet 8/4/2011 13:00'!
number
	^ self new
		setParser: (PPPredicateObjectParser matching: #digit asParser plus message: 'number expected');
		name: 'num'
		! !

!CLIParameter class methodsFor: 'factory' stamp: 'DamienPollet 8/4/2011 13:17'!
path
	self shouldBeImplemented.
	"^ self new
		setParser: (PPPredicateObjectParser matching: FilesystemPathParser message: 'path expected');
		name: 'path'
	"! !

!CLIParameter class methodsFor: 'factory' stamp: 'DamienPollet 8/4/2011 13:16'!
url
	self shouldBeImplemented.
	"^ self new
		setParser: (PPPredicateObjectParser matching: urlParser message: 'URL expected');
		name: 'url'
	"! !

!CLIParameter methodsFor: 'accessing' stamp: 'DamienPollet 8/4/2011 10:19'!
description
	^ self shouldBeImplemented! !

!CLIParameter methodsFor: 'initialization' stamp: 'DamienPollet 8/4/2011 13:14'!
initialize
	isOptional := isMultiple := false! !

!CLIParameter methodsFor: 'accessing' stamp: 'DamienPollet 8/4/2011 17:06'!
name
	"Name of this parameter in the synopsis. Should reveal its type, role, and multiplicity."
	^ name! !

!CLIParameter methodsFor: 'accessing' stamp: 'DamienPollet 8/4/2011 17:18'!
name: aString
	"Name of this parameter in the synopsis. Should reveal its type, role, and multiplicity.
	
	Brackets and punctuation often denote this:
		foo			keyword (typed as is)
		<foo>		meta-syntactic
		foo...		several items of the foo kind
		[foo|bar]	either one
		[foo]		optionally a foo
		[foo...]		zero or more foos"
	
	name := aString! !

!CLIParameter methodsFor: 'initialization' stamp: 'DamienPollet 8/4/2011 13:13'!
optional
	isOptional := true.
	parser := parser optional! !

!CLIParameter methodsFor: 'accessing' stamp: 'DamienPollet 8/4/2011 11:48'!
parser
	^ parser! !

!CLIParameter methodsFor: 'initialization' stamp: 'DamienPollet 8/4/2011 13:13'!
plus
	isMultiple := true.
	parser := parser plus! !

!CLIParameter methodsFor: 'initialization' stamp: 'DamienPollet 8/4/2011 11:47'!
setParser: aParser
	parser := aParser! !

!CLIParameter methodsFor: 'initialization' stamp: 'DamienPollet 8/4/2011 13:13'!
star
	isOptional := isMultiple := true.
	parser := parser star! !

!CLITerm methodsFor: 'parsing' stamp: 'DamienPollet 8/4/2011 11:41'!
parseOn: aStream
	^ self parser parseOn: aStream! !

PPSmalltalkGrammarTests subclass: #PPCoralGrammarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Tests'!

PPCoralGrammarTest subclass: #PPCoralCompilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Tests'!

!PPCoralCompilerTest methodsFor: 'accessing' stamp: 'StephaneDucasse 12/8/2009 17:55'!
parserClass
	^ PPCoralParser! !

!PPCoralCompilerTest methodsFor: 'tests' stamp: 'StephaneDucasse 12/8/2009 17:55'!
testABlock
	"self debug: #testABlock"
	
	| res |
	res := PPCoralParser parse: '[ 1 + 2]'.
	self assert: res = #(3).
! !

!PPCoralCompilerTest methodsFor: 'tests' stamp: 'TestRunner 12/9/2009 21:16'!
testAccessIV
	"self debug: #testAccessIV"

	self shouldnt: [PPCoralParser parse: '[
	Object < #SaBox 
		iv: ''bob'' 
	]'
	] raise: Error.

	self shouldnt: [PPCoralParser parse: '
		SaBox>>initialize
		[
		<category: ''initialize release''>
		<authorInitials: ''him''>
		bob := ''Script test working'']'
	] raise: Error.

	self shouldnt: [PPCoralParser parse: '
		SaBox>> printOn: aStream
	[
		"<category: ''printing''>
		<authorInitials: ''him''>"
		aStream nextPutAll: bob
	]'
	] raise: Error.

! !

!PPCoralCompilerTest methodsFor: 'tests' stamp: 'StephaneDucasse 12/8/2009 17:55'!
testAnotherBlock
	"self debug: #testAnotherBlock"
	
	self assert: (PPCoralParser parse: '[Beeper beep] ') = {Beeper}						
	! !

!PPCoralCompilerTest methodsFor: 'tests' stamp: 'sd 11/8/2010 09:53'!
testBangAlone
	"self debug: #testBangAlone"
	
	
	self shouldnt: [(PPCoralParser parse: '#!!/bin/usr/coralNegated')] raise: Error.
	
	self shouldnt: [(PPCoralParser parse: '#!!/bin/usr/coralNegated'     )] raise: Error
		
	! !

!PPCoralCompilerTest methodsFor: 'tests' stamp: 'sd 11/8/2010 10:23'!
testBangProgram
	"self debug: #testBangProgram"
	
	self assert: 
		(PPCoralParser parse: '#!!/bin/usr/coralNegated 
	Point>>blue 
	    [^ 2]
	
	Point>>red 
	    [^ self blue]
	
	[Point new red = 2]' 
		) = #(blue red true)
	! !

!PPCoralCompilerTest methodsFor: 'tests' stamp: 'TestRunner 12/17/2009 14:43'!
testBashHeader
	"self debug: #testBashHeader"
	
	Smalltalk at: #FooBar put: 666.
	self shouldnt: [PPCoralParser parse: 
		'#!!/bin/sh
		[ Smalltalk at: #FooBar put: 33. ]
		'] raise: Error.
	self assert: (Smalltalk at: #FooBar) =33.
	Smalltalk removeKey: #FooBar! !

!PPCoralCompilerTest methodsFor: 'tests' stamp: 'sd 11/8/2010 10:21'!
testBlueProgram
	"self debug: #testBlueProgram"
	"Pay attention the test should use a class that is in the image"
	

	self assert: (PPCoralParser parse: 'Point>>blue[^2]' )= #(#blue)
	! !

!PPCoralCompilerTest methodsFor: 'tests' stamp: 'sd 11/8/2010 10:21'!
testBlueWithSpacesProgram
	"self debug: #testBlueWithSpacesProgram"
	
	self assert: 
		(PPCoralParser parse: '
	Point>>blue 
	    [^ 2]
' 
		) = #(blue) 
	! !

!PPCoralCompilerTest methodsFor: 'tests' stamp: 'sd 11/8/2010 10:24'!
testDefineAMethod
	"self debug: #testDefineAMethod"
	
	PPCoralParser parse: 'Point >>blue [^ 2]'.
	self assert: (self class environment at: #Point) new blue = 2.
	(self class environment at: #Point) removeSelector: #blue.! !

!PPCoralCompilerTest methodsFor: 'tests' stamp: 'sd 11/8/2010 10:22'!
testDefineAMethodWithExtraDot
	"self debug: #testDefineAMethodWithExtraDot"
	
	PPCoralParser parse: 'Point>>blue [^ 2 . ]'.
	self assert: Point new blue = 2.
	Point removeSelector: #blue.! !

!PPCoralCompilerTest methodsFor: 'tests' stamp: 'StephaneDucasse 12/7/2009 17:02'!
testFullProgram
	"self debug: #testFullProgram"

	super testFullProgram ! !

!PPCoralCompilerTest methodsFor: 'tests' stamp: 'TestRunner 12/7/2009 23:27'!
testMethodUnary1
	"self debug: #testMethodUnary1"

	super testMethodUnary1.
	self assert: (result = #coralNegated)
	"
	self assert: result isMethod.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size = 1.
	self assert: result body statements first isReturn.
	self assert: result body statements first value isMessage.
	self assert: result body statements first value receiver isLiteral.
	self assert: result body statements first value selector = #-.
	self assert: result body statements first value arguments size = 1.
	self assert: result body statements first value arguments first isVariable
	"! !

!PPCoralCompilerTest methodsFor: 'tests' stamp: 'TestRunner 12/17/2009 14:48'!
testScript
	"self debug: #testScript"
	
	self shouldnt: [PPCoralParser parse: '[
	Object subclass: #SaBox
		instanceVariableNames: ''bob''
		classVariableNames: ''''
		poolDictionaries: ''''
		category: ''SandBox''
	]

	SaBox >> initialize
	[
		<category: ''initialize release''>
		<authorInitials: ''him''>
		bob := ''Script test working''.
	]

	SaBox >> printOn: aStream
	[
		"<category: ''printing''>
		<authorInitials: ''him''>"
		aStream nextPutAll: bob
	]

	SaBox class >> dummy
	[
		<authorInitials: ''him''>
		^3
	]

	[
	SaBox new printString.
	]'] raise: Error.

	self assert: (Smalltalk at: #SaBox ifAbsent:[nil]) notNil.
	self assert: (Smalltalk at: #SaBox ifAbsent:[nil])  dummy = 3! !

!PPCoralCompilerTest methodsFor: 'tests' stamp: 'TestRunner 12/17/2009 14:51'!
testScript1
	"self debug: #testScript1"

	self shouldnt: [PPCoralParser parse: '[
	Object subclass: #SaBox
		instanceVariableNames: ''bob''
		classVariableNames: ''''
		poolDictionaries: ''''
		category: ''SandBox''
	]'
	] raise: Error.

	self shouldnt: [PPCoralParser parse: '
		SaBox>>initialize
		[bob := ''Script test working'']'
	] raise: Error.

	PPCoralParser parse: 'SaBox>>bob
		[^ bob ]'.
	self assert: (Smalltalk at: #SaBox) new bob = 'Script test working'
! !

!PPCoralCompilerTest methodsFor: 'tests' stamp: 'sd 11/8/2010 10:24'!
testWhiteSpaceAfterClassName
	"self debug: #testWhiteSpaceAfterClassName"
	self shouldnt: [PPCoralParser parse: '
		Point >> printOn: aStream
	[
		"<category: ''printing''>
		<authorInitials: ''him''>"
		aStream nextPutAll: bob
	]'
	] raise: Error.! !

!PPCoralGrammarTest methodsFor: 'accessing' stamp: 'StephaneDucasse 12/8/2009 17:56'!
parserClass
	^ PPCoralGrammar! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'StephaneDucasse 12/7/2009 15:00'!
testBang
	"self debug: #testBang"

	self 
		parse: '#!!/usr/bin/work '
		rule: #program.
		
	self 
		parse: '#!!/usr/bin/work   '
		rule: #program.
		
		
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'TestRunner 12/7/2009 16:59'!
testBangFullProgram
	"self debug: #testBangFullProgram"

	self 
		parse: '#!!/bin/usr/
		[Beeper beep]
		
				Point>> foo 
					[  1 + 2]
				
				Point>> foo2 
					[ ^ 1 + 2]
				
				[Beeper beep]'
		rule: #program
		
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'TestRunner 12/7/2009 15:00'!
testBangNoSpace
	"self debug: #testBangNoSpace"

	self 
		parse: '#!!/usr/bin/work'
		rule: #program
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'sd 10/3/2009 13:27'!
testBlock
	"self debug: #testBlock"

	self 
		parse: ' [Beeper beep]'
		rule: #block
		
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'sd 10/3/2009 13:28'!
testFullProgram
	"self debug: #testFullProgram"

	self 
		parse: ' [Beeper beep]
		
				Point>> foo 
					[  1 + 2]
				
				Point>> foo2 
					[ ^ 1 + 2]
				
				[Beeper beep]'
		rule: #program
		
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'TestRunner 12/7/2009 16:59'!
testMethod
	"self debug: #testMethod"

	self 
		parse: 'SandBox>>blue [^ 2]'
		rule: #program
		
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/30/2009 17:10'!
testMethodBinary1
	"self debug: #testMethodBinary1"

	self 
		parse: 'Point>>+ arg [^ self + arg]'
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/30/2009 17:10'!
testMethodBinary2
	"self debug: #testMethodBinary2"

	self 
		parse: '     Point    >>   + arg [^ self + arg ]'
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/30/2009 17:11'!
testMethodBinary3
	"self debug: #testMethodBinary3"

	self 
		parse: '     Point    >>   + arg 
							[^ self + arg ]   '
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/30/2009 17:11'!
testMethodBinary4
	"self debug: #testMethodBinary4"

	self 
		parse:  '     Point  class  >>   + arg 
							[^ self + arg ]   '
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/30/2009 17:12'!
testMethodKeyword1
	"self debug: #testMethodKeyword1"

	self 
		parse: 'Point>>coralSetX: x y:y
					 [^ self class new setX: x ; setY: y ]'
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/30/2009 17:13'!
testMethodKeyword2
	"self debug: #testMethodKeyword2"

	self 
		parse: 'Point >>  coralSetX: x y:y
					 [^ self class new setX: x ; setY: y ] '
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/30/2009 17:13'!
testMethodKeyword3
	"self debug: #testMethodKeyword3"

	self 
		parse: '   Point >>  coralSetX: x y:        
		   y
					 [^ self class new setX: x ; setY: y ] '
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/30/2009 17:13'!
testMethodKeyword4
	"self debug: #testMethodKeyword4"

	self 
		parse: '   Point class >>  coralNewX: x y:        
		   y
					 [^ self  new setX: x ; setY: y ] '
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'TestRunner 12/7/2009 16:38'!
testMethodUnary1
	"self debug: #testMethodUnary1"

	self 
		parse: 'Point>>coralNegated[^0-self]'
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'TestRunner 12/7/2009 16:32'!
testMethodUnary2
	"self debug: #testMethodUnary2"

	self 
		parse: '   Point  >>  coralNegated   [ ^ 0 - self ]  '
		rule: #method
		
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'TestRunner 12/7/2009 16:30'!
testMethodUnary3
	"self debug: #testMethod3"

	"for now let us test the following"
	self 
		parse: '   Point >> coralNegated [^ 0 - self]     '
		rule: #method
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'sd 12/7/2009 13:45'!
testMethodUnaryClass4
	"self debug: #testMethodUnaryClass4"

	"for now let us test the following"
	self 
		parse: '   Point class >> coralNegated [^ 0 - self]     '
		rule: #program
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'sd 10/3/2009 13:25'!
testProgram
	"self debug: #testProgram"

	self 
		parse: ' [Beeper beep]'
		rule: #program
		
	! !

!PPCoralGrammarTest methodsFor: 'tests' stamp: 'sd 10/3/2009 13:26'!
testProgramAsASingleBlock
	"self debug: #testProgram"

	self 
		parse: ' [Beeper beep]'
		rule: #program
		
	! !

!UnixProcess methodsFor: '*coral' stamp: 'ms 10/5/2006 14:15'!
newLineInConsole
	
	^String lf! !

!WindowsProcess methodsFor: '*coral' stamp: 'ms 10/5/2006 14:16'!
newLineInConsole
	
	^String cr, String lf! !

!SmalltalkImage methodsFor: '*coral' stamp: 'StephaneDucasse 1/3/2010 17:30'!
associationForKey: aKey
	"Returns the association of a key and its value when passed to the vm"
	
	^ self extractParameters associationAt: aKey
	! !

!SmalltalkImage methodsFor: '*coral' stamp: 'AdrienBarreau 10/11/2010 19:47'!
extractMinusParameters
	"Returns a dictionary matching parameters beginning by a minus character and the list of the next parameters.
	Here is an example: 
		I suppose I run pharo with: `pharo myImage.image 1 2 3 woah -minus1 'Hello' -minus2 -minus3 'Hello' 'World'`.
		This message will return a dictionary with: 
			* --> #(1 2 3 'woah')
			minus1 --> #('Hello')
			minus2 --> #()
			minus3 --> #('Hello' 'World')"
			
	| args str index |
	
	args := OrderedCollection new.

	str := self getSystemAttribute: (index := 2).
	[ str isNil ] whileFalse: [ args add: str. str := self getSystemAttribute: (index := index + 1) ].

	^ self extractMinusParametersFrom: args! !

!SmalltalkImage methodsFor: '*coral' stamp: 'AdrienBarreau 10/13/2010 13:16'!
extractMinusParametersFrom: arguments
	| dict previous previousWithMinus args |
	
	dict := Dictionary new.
	
	arguments isEmptyOrNil ifTrue: [ ^ dict ].
	
	args := OrderedCollection withAll: arguments.

	previous := previousWithMinus := args detect: [ :each | each first = $- ] ifNone: [ String space ].
	[ args isEmpty or: [ args first = previous ] ] whileFalse: [ dict at: #* put: (dict at: #* ifAbsent: [ #() ]), (Array with: args first). args removeFirst ].
	
	args do: [ :each |
		(each first = $-)
			ifTrue: [ 
				(previous first = $-) ifTrue: [ dict at: previous allButFirst put: #() ].
				previousWithMinus := each ]
			ifFalse: [ dict at: previousWithMinus allButFirst put: ((dict at: previousWithMinus allButFirst ifAbsent: [ #() ]), (Array with: each)) ].
				
		previous := each.
	].

	(previous first = $-) ifTrue: [ dict at: previous allButFirst put: #() ].

	^ dict! !

!SmalltalkImage methodsFor: '*coral' stamp: 'StephaneDucasse 1/3/2010 17:31'!
hasKey: aKey
	"Returns true if the key was passed in argument when launching the vm."
	
	self extractParameters 
		at: aKey ifAbsent: [^ false].
	^ true.! !

!SmalltalkImage methodsFor: '*coral' stamp: 'StephaneDucasse 1/3/2010 17:45'!
shouldHaltAtStart
	"Coral specific: 
	In coral you can launch the vm that way
	
	 /Applications/Squeak/Squeak\ 4.2.2beta1U.app/Contents/MacOS/Squeak\ VM\ Opt  
		coral.image 
		Hello.st -noquit
	
	-noquit means that the vm should not quit after execution (in such case -headless should not be on)
		 /Applications/Squeak/Squeak\ 4.2.2beta1U.app/Contents/MacOS/Squeak\ VM\ Opt 
				 -headless coral.image Hello.st 
	
	-haltAtStart means that a break point should be on before executing the script (in such case -headless 		should not be on)
	"
	^ (self hasKey: '-HALTATSTART')! !

!SmalltalkImage methodsFor: '*coral' stamp: 'StephaneDucasse 1/3/2010 17:37'!
shouldQuitAfterExecution
	"Coral specific: 
	In coral you can launch the vm that way
	
	 /Applications/Squeak/Squeak\ 4.2.2beta1U.app/Contents/MacOS/Squeak\ VM\ Opt  
		coral.image 
		Hello.st -noquit
	
	-noquit means that the vm should not quit after execution (in such case -headless should not be on)
		 /Applications/Squeak/Squeak\ 4.2.2beta1U.app/Contents/MacOS/Squeak\ VM\ Opt 
				 -headless coral.image Hello.st 
	
	-haltAtStart means that a break point should be on before executing the script (in such case -headless 		should not be on)
	"
	^ (self hasKey: '-NOQUIT') not! !

Object subclass: #Console
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

Console class
	instanceVariableNames: 'prompt history'!

!Console commentStamp: 'DamienPollet 7/28/2011 16:03' prior: 0!
Console provides convenient access to standard input/output streams plus methods to help display text on a unix terminal (using ANSI control sequences).

!

Console class
	instanceVariableNames: 'prompt history'!

!Console class methodsFor: 'output' stamp: 'StephaneDucasse 12/8/2009 17:59'!
<< aStream

	OSProcess thisOSProcess stdOut nextPutAll: aStream! !

!Console class methodsFor: 'private' stamp: 'OlivierAuverlot 12/7/2010 21:27'!
addToHistory: aString
	"add command line to history"

	history add: aString.! !

!Console class methodsFor: 'private' stamp: 'OlivierAuverlot 12/4/2010 21:33'!
banner
	"Display the Coral banner"

	Console printNl: '                                            \   /'.
	Console printNl: '------------------------------------------    *'.
	Console printNl: 'Pharo                                       /|=|\'.	
	Console printNl: 'open-source Smalltalk-inspired environment   |=|'.	
	Console printNl: '------------------------------------------  |===|'.! !

!Console class methodsFor: 'console' stamp: 'OlivierAuverlot 12/24/2010 15:03'!
clear
	"clear the history"
	history removeAll
! !

!Console class methodsFor: 'output' stamp: 'StephaneDucasse 12/8/2009 17:59'!
cr 
	
	^OSProcess thisOSProcess newLineInConsole! !

!Console class methodsFor: 'output' stamp: 'OlivierAuverlot 11/19/2010 19:28'!
displayAttributes: attributes
	"Sets multiple display attribute settings
	
	0	Reset all attributes
	1	Bright
	2	Dim
	4	Underscore	
	5	Blink
	7	Reverse
	8	Hidden

	Foreground Colours
	30	Black
	31	Red
	32	Green
	33	Yellow
	34	Blue
	35	Magenta
	36	Cyan
	37	White

	Background Colours
	40	Black
	41	Red
	42	Green
	43	Yellow
	44	Blue
	45	Magenta
	46	Cyan
	47	White

<ESC>[{attr1};...;{attrn}m
	
	Console displayAttribute: #(1 33 40)"


	| stream cmd |
	
	cmd := WriteStream on: String new.
	stream := attributes readStream.
	
	stream do: [ 
		:att | 
		cmd nextPutAll: att asString.
		(stream atEnd not) ifTrue: [ cmd nextPutAll: ';' ]
	].

	Console esc: '[' , (cmd contents) , 'm'.! !

!Console class methodsFor: 'output' stamp: 'OlivierAuverlot 11/22/2010 12:01'!
eraseScreen
	"Erases the screen with the background colour and moves the cursor to home."

	Console esc: '[2J'.
	! !

!Console class methodsFor: 'output' stamp: 'OlivierAuverlot 11/19/2010 12:27'!
esc: escapeSequence
	"Output escape sequence to console"

	Console print: #[27] , escapeSequence.
		! !

!Console class methodsFor: 'console' stamp: 'OlivierAuverlot 12/24/2010 15:40'!
go: lineNumber
	"execute the specified line in history"
	
	history removeLast.
	
	(lineNumber > 0 & lineNumber <= history size) ifTrue: [
		[ ScriptInterpreter parse: '[' , (history at: lineNumber) , ']' ]
			on: Exception
			do: [ :ex | Console printNl: ex printString ]
	]
		
		! !

!Console class methodsFor: 'private' stamp: 'OlivierAuverlot 12/7/2010 21:24'!
initHistory
	"initialize the console history"

	history := OrderedCollection new.! !

!Console class methodsFor: 'private' stamp: 'OlivierAuverlot 12/7/2010 21:48'!
listHistory
	"display the content of the console history"

	history doWithIndex: [ :each :i | Console printNl: (i asString , ' -> ' , each) ].! !

!Console class methodsFor: 'output' stamp: 'OlivierAuverlot 11/19/2010 18:16'!
locate: position
	"Sets the cursor position where subsequent text will begin"
	
	Console esc: '[' , (position y) asString , ';' , (position x) asString , 'f'.
	! !

!Console class methodsFor: 'output' stamp: 'AdrienBarreau 5/10/2011 15:31'!
newLine
	
	^OSProcess thisOSProcess newLineInConsole! !

!Console class methodsFor: 'output' stamp: 'ms 10/1/2006 18:50'!
nextPutAll: aStream

	OSProcess thisOSProcess stdOut nextPutAll: aStream! !

!Console class methodsFor: 'output' stamp: 'OlivierAuverlot 11/19/2010 21:35'!
plot: position
	"comment stating purpose of message"

	Console locate: position; print: ' '.! !

!Console class methodsFor: 'output' stamp: 'OlivierAuverlot 12/7/2010 22:07'!
print: aStream

	Console << aStream.! !

!Console class methodsFor: 'output' stamp: 'ms 10/1/2006 18:10'!
printError: aStream

	OSProcess thisOSProcess stdErr nextPutAll: aStream! !

!Console class methodsFor: 'output' stamp: 'OlivierAuverlot 12/24/2010 16:36'!
printNl: aStream

	Console << (aStream,Console newLine).
	! !

!Console class methodsFor: 'output' stamp: 'OlivierAuverlot 12/24/2010 16:33'!
printTab
	"display a tab"

	Console << #[9]! !

!Console class methodsFor: 'output' stamp: 'OlivierAuverlot 12/4/2010 21:23'!
prompt
	"return the prompt"

	^prompt! !

!Console class methodsFor: 'output' stamp: 'OlivierAuverlot 12/4/2010 21:24'!
prompt: aString
	"set the prompt"

	prompt := aString.	! !

!Console class methodsFor: 'input' stamp: 'OlivierAuverlot 12/4/2010 22:04'!
read
	"Read a string until newline"
	| inputStr exitShell |
	
	exitShell := false.
		
	Console print: Console prompt.
		
	[ exitShell ] whileFalse: [	
				((inputStr := OSProcess readFromStdIn) = '') ifFalse: [
						inputStr := inputStr allButLast.
						exitShell := true. ]].
				
	^inputStr
	
! !

!Console class methodsFor: 'output' stamp: 'OlivierAuverlot 11/19/2010 19:28'!
resetAllAttributes
	"Reset all display attributes"
	
	Console displayAttributes: #(0).
! !

Object subclass: #CoralInstaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!CoralInstaller commentStamp: 'DamienPollet 7/28/2011 16:04' prior: 0!
A CoralInstaller is responsible to install accessory files to integrate Coral with the shell and environment of the host system.
!

!CoralInstaller class methodsFor: 'file creation' stamp: 'DamienPollet 8/7/2011 00:37'!
createFileNamed: aFileName withContents: aString
	| file |
	file := (FSFilesystem onDisk entryAt: aFileName) reference.
	file writeStreamDo: [ :str |
		str truncate.
		str nextPutAll: aString withUnixLineEndings.
		str close ].
	^ file

! !

!CoralInstaller class methodsFor: 'file creation' stamp: 'DamienPollet 8/7/2011 00:38'!
createWrapperNamed: aString withContents: contentString
	| script |
	script := self createFileNamed: aString withContents: contentString.
	OSProcess command: 'chmod u+x "' , script pathString , '"'! !

!CoralInstaller class methodsFor: 'script generation' stamp: 'OlivierAuverlot 11/24/2010 14:19'!
generateAllExamples
	"self generateAllExamples"
	(CoralScriptExamples class allMethodsInCategory: #'script examples') do: [ :selector | 
		self generateScript: selector 	
	]

! !

!CoralInstaller class methodsFor: 'script generation' stamp: 'DamienPollet 8/7/2011 00:47'!
generateCoralDebugScript
	"self generateCoralDebugScript"

	self createWrapperNamed: 'coralDebug.sh' withContents:
'#!! /bin/sh
vm=''', Smalltalk vmFullPath, '''
image=''', (Smalltalk getSystemAttribute: 1), '''

for i in "$@"; do
	params="$params \"$i\""
done

"$vm" "$image" "`pwd`/$1" -noquit -coralArgs "$params"
'
! !

!CoralInstaller class methodsFor: 'script generation' stamp: 'DamienPollet 8/7/2011 00:45'!
generateCoralScript
	"self generateCoralScript"

	self createWrapperNamed: 'coral.sh' withContents:
'#!! /bin/sh
vm=''', Smalltalk vmFullPath, '''
image=''', (Smalltalk getSystemAttribute: 1), '''

for i in "$@"; do
	params="$params \"$i\""
done

"$vm" -headless "$image" "`pwd`/$1" -coralArgs "$params"
'
! !

!CoralInstaller class methodsFor: 'script generation' stamp: 'AdrienBarreau 10/13/2010 14:11'!
generateScript: aSelector
	self createFileNamed: aSelector asString, '.cst' withContents: (CoralScriptExamples perform: aSelector)! !

Object subclass: #CoralREADME
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!CoralREADME commentStamp: '<historical>' prior: 0!
This project lives here:

http://www.squeaksource.com/Coral/

To load Coral, simply evaluate the following in a fresh image:

ScriptLoader new installer ss project: 'Coral'; install: 'LoadCoral'.

For more information (workspace documentation on class side), just evaluate:

self initialize
!

!CoralREADME class methodsFor: 'fileExample' stamp: 'StephaneDucasse 2/14/2010 11:29'!
creatingAFile

	"str := FSUnixFilesystem new writeStreamOn: 'giffle'.
str nextPutAll: 'zzzzzzzzzz'.
str close"

"(FSDiskFilesystem current childrenAt: FSDiskFilesystem current
workingDirectory) do:
   [:each | each printOn: Transcript cr ].
Transcript flush.

Speaking of current dir...
FSDiskFilesystem current workingDirectory isWorkingDirectory"

"FSDiskFilesystem current workingDirectory"! !

!CoralREADME class methodsFor: 'comment' stamp: 'StephaneDucasse 2/12/2010 16:19'!
faq
	^ '     '! !

!CoralREADME class methodsFor: 'initialization' stamp: 'on 2/25/2009 12:15'!
initialize
	super initialize.
	
	self openWorkspaceLabeled: 'READ ME' withContents: self readMe.
	self openWorkspaceLabeled: 'TO DO' withContents: self todo.
	self openWorkspaceLabeled: 'FAQ' withContents: self faq.! !

!CoralREADME class methodsFor: 'private' stamp: 'StephaneDucasse 9/3/2009 17:45'!
openWorkspaceLabeled: label withContents: contents
	| info |
	info := Workspace new.
	info contents: contents.
	info openLabel: label! !

!CoralREADME class methodsFor: 'comment' stamp: 'OlivierAuverlot 11/26/2010 15:27'!
readMe

	^ '"INSTRUCTIONS

TO REVISED.... 

[We assume you are on a Mac -- you will need to adapt these instructions for other platforms ...]"

"1) Save this image as coral.image"

SmalltalkImage current saveAs: ''coral.image''.

"2) Generate coral.sh "

CoralInstaller generateCoralScript.
CoralInstaller generateCoralDebugScript.

"3)  make them executable: chmod +x coral.sh coralDebug.sh"

"4) Generate examples implemented in CoralScriptExamples"

CoralInstaller generateAllExamples.

"5) Execute an example"

"./coral.sh hello.cst"

'! !

!CoralREADME class methodsFor: 'comment' stamp: 'StephaneDucasse 12/8/2009 18:36'!
todo
	^ '"TO DO ITEMS
- clean up dead code (current)
- check extensions made in previous package 
- merge to get back the ancestors
- check ScriptInterpreter?? 
	Do we need to create a class for a script
	How do we store a execution component:  [ ] and list of them [ ]
	for now we can only manipulate scripts outside the image. 

- refresh the readme
- make sure we can pass a script
- remove dependencies on fileman

- support for #!! notation (done)
- installer for #!! script runner

- filename or rio for file
- debug mode for scripts (escape to image)
- passing arguments to scripts
- pipes and filters (stdin and stdout)
- redirecting Smalltalk errors to stderr
- evaluating external Unix commands (cf. backtick commands)
- multi-=platform support (installers?)
- environment to develop and debug scripts (extend class browser?)
- demo scripts
- tutorial"'! !

!CoralREADME class methodsFor: 'fileExample' stamp: 'StephaneDucasse 2/15/2010 18:51'!
tutorial

	"str := FSUnixFilesystem new writeStreamOn: 'giffle'.
str nextPutAll: 'zzzzzzzzzz'.
str close

FSDiskFilesystem current workingDirectory allChildren

FSDiskFilesystem current workingDirectory allEntries


FSDiskFilesystem current root -> / 
FSDiskFilesystem current root class -> FSReference

|working cache|
working := FSDiskFilesystem current working.
cache := working / 'package-cache'.
cache entry creationdate
	
	
	(FSDiskFilesystem current childrenAt: FSDiskFilesystem current workingDirectory )
	
	FSPath / 'plonk' / 'leaffile'. 
		/plonk/leaffile
	FSPath * 'plonk' / 'leaffile'. 
		 plonk/leaffile
	
	
	
	
	"! !

Object subclass: #CoralScriptExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!CoralScriptExamples commentStamp: 'DamienPollet 7/28/2011 16:05' prior: 0!
I'm a library of example Coral scripts.

I could probably be merged into CoralInstaller.!

!CoralScriptExamples class methodsFor: 'script examples' stamp: 'OlivierAuverlot 11/24/2010 14:17'!
scriptCarpet
		"generates a carpet with random colors"

^'[
	Console resetAllAttributes.
	Console eraseScreen.

	(1 to: 80) do: [ :x | 
		(1 to: 20) do: [ :y |
			Console displayAttributes: { ((10 atRandom) + 29) . 7 . ((10 atRandom) + 39) }.
			Console plot: x @ y.
		]
	].
	
	Console resetAllAttributes.

]'! !

!CoralScriptExamples class methodsFor: 'script examples' stamp: 'AdrienBarreau 10/13/2010 14:13'!
scriptCreationOfFolderAndFiles
	"CoralInstaller generateScript: #scriptCreationOfFolderAndFiles"

	^ '"This script takes one parameter: a path. It will create a folder named CoralGenerated at the path.
If this folder exists, it is deleted first. In CoralGenerated, a few folders and a file are created."

[
	| fs folder |

	fs := FSDiskFilesystem currentClass createDefault.
	folder := CoralScriptWriting getAllArgumentsWithoutMinusButScriptName at:1 ifAbsent: [ String empty ].
	
	folder isEmpty 
		ifTrue: [ Console<<(''Use: '', CoralScriptWriting getScriptName, '' path'') ]
		ifFalse: [ 
			| ref |

			ref := fs referenceTo: folder.
			ref exists
				ifFalse: [ Console printError: ''The path should exist'' ]
				ifTrue: [
					| stream baseRef |
					baseRef := (ref / ''CoralGenerated'').
					baseRef exists ifTrue: [ baseRef deleteAll ].
					baseRef createDirectory.
					((ref / ''CoralGenerated'') / ''a'') createDirectory.
					((ref / ''CoralGenerated'') / ''b'') createDirectory.
					(((ref / ''CoralGenerated'') / ''b'') / ''c'') createDirectory.
					stream := ((((ref / ''CoralGenerated'') / ''b'') / ''c'') / ''coral.txt'') writeStream.
					stream nextPutAll: ''FileGenerated with Coral''.
					stream close.
					Console<<(CoralScriptWriting getScriptName, '' done.'')
				]
		]
]	
'! !

!CoralScriptExamples class methodsFor: 'script examples' stamp: 'AdrienBarreau 5/10/2011 17:55'!
scriptFewThingsWithOSProcess
	^
'"This script does nothing useful ... but it shows a couple of things you can use while scripting"

[
	| process |
	
	process := OSProcess thisOSProcess.
	
	Console << ''Let''''s take a look at many points of OSProcess!!'' << String lf.
	Console << ''------------------------------------------------------------'' << String lf << String lf.
	
	Console << ''Environment variables:'' << String lf.
	Console << ''------'' << String lf.
	process environment associationsDo: [ :each | Console << each key << '' = '' << each value << String lf ].
	
	Console << String lf << ''You can run shell commands. Here is "ls -la *.cst":'' << String lf.
	Console << ''------'' << String lf.
	process waitForCommand: ''ls -la *.cst''.
	
	Console << String lf << ''You can change the working directory.'' << String lf.
	Console << ''------'' << String lf..
	Console << ''pwd: ''.
	process waitForCommand: ''pwd''.
	Console << ''Changing working directory for /'' << String lf.
	process chDir: ''/''.
	Console << ''pwd: ''.
	process waitForCommand: ''pwd''.
	Console << ''ls:'' << String lf.
	process waitForCommand: ''ls''.

	Console << String lf << CoralScriptWriting getScriptName << '' done.''
]
'! !

!CoralScriptExamples class methodsFor: 'script examples' stamp: 'AdrienBarreau 10/13/2010 16:36'!
scriptForScriptTestCoralScriptWriting
	"CoralInstaller generateScript: #scriptForScriptTestCoralScriptWriting"

	^ '[
	| fs os |
	
	fs := FSDiskFilesystem currentClass createDefault.
	os := ThisOSProcess thisOSProcess.
	
	os chDir: (fs referenceTo: ''.'') asAbsolute asString.
	CoralInstaller generateScript: #scriptTestCoralScriptWriting.
	
	os waitForCommand: ''./coral.sh scriptTestCoralScriptWriting.cst arg1 arg2 -minus1 arg3 -minus2 -minus3 arg4 arg5''.
	
	(fs referenceTo: ''./scriptTestCoralScriptWriting.cst'') delete.
	
	Console << (CoralScriptWriting getScriptName, '' done.'')
]	
'! !

!CoralScriptExamples class methodsFor: 'script examples' stamp: 'OlivierAuverlot 11/24/2010 10:41'!
scriptHappyFace

  ^'[
	Console resetAllAttributes.
	Console displayAttributes: #(31 7 42).
	Console eraseScreen.

	Console locate: 10@5; print: ''  ''.
	Console locate: 10@6; print: '' O''.
	Console locate: 30@5; print: ''  ''.
	Console locate: 30@6; print: '' O''.

	Console plot: 20@10.
	Console plot: 20@11.

	Console plot: 14@16.
	Console plot: 25@16.

	Console locate: 15@17; print: ''          ''.
	
	Console locate: 1@20.
	Console resetAllAttributes.
]'
! !

!CoralScriptExamples class methodsFor: 'script examples' stamp: 'AdrienBarreau 5/10/2011 18:11'!
scriptHello

  ^'[
	Console print: ''Coral is working'', String lf.
	Console print: ''Yahoo!!''
]'! !

!CoralScriptExamples class methodsFor: 'script examples' stamp: 'AdrienBarreau 10/13/2010 14:14'!
scriptPrintArguments
	"CoralInstaller generateScript: #scriptPrintArguments"

	^ '"This script takes * arguments and print them with 3 arguments-using methods"
	
[
	Console printNl:''getScriptName: '', CoralScriptWriting getScriptName.

	Console printNl: ''getAllArgumentsWithoutMinus:''.
	CoralScriptWriting getAllArgumentsWithoutMinus do: [ :each | Console printNl: each ].

	Console printNl: ''getAllArgumentsWithoutMinusButScriptName:''.
	CoralScriptWriting getAllArgumentsWithoutMinusButScriptName do: [ :each | Console printNl: each ]
]	
'! !

!CoralScriptExamples class methodsFor: 'script examples' stamp: 'AdrienBarreau 10/13/2010 14:15'!
scriptSynchronizeSecondFolderWithFirst
	"CoralInstaller generateScript: #scriptSynchronizeSecondFolderWithFirst"

	^ '"This script takes two paths as parameters. They should be two folders. This script will synchronize the
second folder with the first.
NB: Can be improve, this example just add the files which does not exist in the folder 2"

[ Object < #TempCoralClass ]

TempCoralClass class>>synchronizeFolder1: folder1 folder2: folder2
[
	| entries1 baseNames2 filesToCreate |
	
	entries1 := folder1 children.
	baseNames2 := folder2 children collect: [ :each | each basename ].
	filesToCreate := entries1 reject: [ :each |  baseNames2 includes: each basename ].
	
	filesToCreate do: [ :each | 
		each isFile 
			ifTrue: [ 
				| readStream |
				readStream := each readStream.
				(folder2 / (each basename)) writeStream nextPutAll: (readStream contents); close.
				readStream close
			]
			ifFalse: [ (folder2 / (each basename)) createDirectory. self synchronizeFolder1: each folder2: (folder2 / (each basename)) ]
	].
]

[
	| args fs folder1 folder2 |
	
	args := CoralScriptWriting getAllArguments.
	(args size = 3) ifFalse: [ Console<<(''Use: '', args first, '' path1 path2''). ^ self ].
	
	fs := FSDiskFilesystem currentClass createDefault.
	folder1 := fs referenceTo: (args at:2).
	folder2 := fs referenceTo: (args at:3).
	
	(folder1 exists & folder2 exists) ifFalse: [ Console printError: ''Error: The two folders should exist.''. ^ self ].
	
	TempCoralClass synchronizeFolder1: folder1 folder2: folder2.
	Console<< (args first, '' done.'').
]	
'! !

!CoralScriptExamples class methodsFor: 'testing scripts' stamp: 'AdrienBarreau 10/13/2010 16:39'!
scriptTestCoralScriptWriting
	"Don't generate this script, but use scriptForScriptTestCoralScriptWriting"

	^ '[ TestCase < #TempCoralClass ]

TempCoralClass>>testGetAllArguments
[
	| args |
	
	args := CoralScriptWriting getAllArguments.
	
	self assert: (args size = 4).
	self assert: ((args at: #*) = #(''scriptTestCoralScriptWriting.cst'' arg1 arg2)).
	self assert: ((args at: #minus1) = #(arg3)).
	self assert: ((args at: #minus2) = #()).
	self assert: ((args at: #minus3) = #(arg4 arg5)).
]

TempCoralClass>>testGetAllArgumentsWithoutMinus
[
	| args |
	
	args := CoralScriptWriting getAllArgumentsWithoutMinus.
	
	self assert: (args size = 3).
	self assert: ((args at:1) = ''scriptTestCoralScriptWriting.cst'').
	self assert: ((args at:2) = ''arg1'').
	self assert: ((args at:3) = ''arg2'').
	
	self assert: (args = (CoralScriptWriting getAllArguments at: #*)).
]

TempCoralClass>>testGetAllArgumentsWithoutMinusButScriptName
[
	| args |
	
	args := CoralScriptWriting getAllArgumentsWithoutMinusButScriptName.
	
	self assert: (args size = 2).
	self assert: ((args at:1) = ''arg1'').
	self assert: ((args at:2) = ''arg2'').
	
	self assert: (args = (CoralScriptWriting getAllArguments at: #*) allButFirst).
	self assert: (args = CoralScriptWriting getAllArgumentsWithoutMinus allButFirst).
]

TempCoralClass>>testGetScriptName
[
	| arg |
	
	arg := CoralScriptWriting getScriptName.
	
	self assert: (arg = ''scriptTestCoralScriptWriting.cst'').
	self assert: (arg = (CoralScriptWriting getAllArguments at: #*) first).
	self assert: (arg = CoralScriptWriting getAllArgumentsWithoutMinus first).
]

[
	| flag |
	
	flag := true.
	TempCoralClass selectors do: [ :each |
		[ TempCoralClass debug: each ] on: TestFailure do: [ Console printNl: ''Test failure: '', each. flag := false ]
	].

	flag ifTrue: [ Console printNl: ''All tests were successfully passed!!''  ]
]'
! !

Object subclass: #CoralScriptLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!CoralScriptLoader commentStamp: 'StephaneDucasse 1/3/2010 17:44' prior: 0!
CoralScriptLoader is responsible to load and debug scripts.
For now you can either launch the vm in 
	- headless mode and you should not use the other coral options. 
	
	#!! /bin/sh
	vm='/Applications/Squeak/Squeak 4.2.2beta1U.app/Contents/MacOS/Squeak VM Opt'
	"$vm" -headless "coral.image" "`pwd`/$1"
	
	You can use ./coral.sh yourscript.psc  (pharoScript) or .cor for coral.
	
	- debug mode
	
	#!! /bin/sh
	vm='/Applications/Squeak/Squeak 4.2.2beta1U.app/Contents/MacOS/Squeak VM Opt'
	"$vm" "coral.image" "`pwd`/$1" -noquit
	
	In debugmode you can specify that the vm does not quit after execution using -noquit and that the execution
	of the script is halted before its execution using -haltAtStart
	 
	-haltAtStart means that a break point should be on before executing the script (in such case -headless should not be on)!

!CoralScriptLoader class methodsFor: 'initialize-release' stamp: 'AdrienBarreau 5/10/2011 21:41'!
initialize
	"self initialize"	
	
	Smalltalk addToStartUpList: self.
	Smalltalk at: #AbstractLauncher ifPresent: [ :arg | (Smalltalk at: #AbstractLauncher) deactivate ].
	Smalltalk at: #CommandLine ifPresent: [ :arg | CodeLoader enableCommandLineHandling: false ]! !

!CoralScriptLoader class methodsFor: 'initialize-release' stamp: 'OlivierAuverlot 12/27/2010 20:51'!
startUp
	"Smalltalk addToStartUpList: self"
	| inputStr exitShell  script |
	
	Console initHistory.
	Console prompt: '> '.	
		
	((SmalltalkImage current getSystemAttribute: 4) = '') 
		ifTrue: [
			Console banner.
			exitShell := false.
				
			[ exitShell ] whileFalse: [
				((inputStr := Console read) = '') 
					ifTrue: [ Console listHistory ]
					ifFalse: [
						Console addToHistory: inputStr.
							[ ScriptInterpreter parse: '[' , inputStr , ']' ]
								on: Exception
								do: [ :ex | Console printNl: ex printString ] ]
					]
		]
		ifFalse: [
			script := ((SmalltalkImage current getSystemAttribute: 2) ifNil:['']) convertFromSystemString.

			script isEmpty ifFalse:[
				CoralScriptWriting resetArguments.
				[PPCoralParser parse: (FileStream readOnlyFileNamed: script) contents] 
					on: Exception
					do: [ :ex | 
						(ex isKindOf: InMidstOfFileinNotification) 
							ifTrue:[ ex resume: false ]
							ifFalse: [
						Smalltalk
							logError: ex printString
							inContext: thisContext
							to: 'CoralDebug.log'.
						Console printNl: ex printString]].
				Console printNl: ''.
				SmalltalkImage current shouldQuitAfterExecution ifTrue: [Smalltalk quitPrimitive]
				]
		]
		
	
! !

Object subclass: #CoralScriptWriting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

CoralScriptWriting class
	instanceVariableNames: 'currentArgs coralArgsCollection'!

!CoralScriptWriting commentStamp: 'DamienPollet 7/28/2011 16:10' prior: 0!
A CoralScriptWriting represents the execution environment of a Coral script, from the script writer's point of view.
!

CoralScriptWriting class
	instanceVariableNames: 'currentArgs coralArgsCollection'!

!CoralScriptWriting class methodsFor: 'arguments' stamp: 'AdrienBarreau 5/16/2011 16:13'!
getAllArguments
	currentArgs ifNil: [ 
		| coralArgs flag |
		flag := true.
		coralArgs := SmalltalkImage current extractMinusParameters.
		
		coralArgs isNil ifTrue: [ flag := false ] ifFalse: [ flag := coralArgs includesKey: #coralArgs ].
		
		flag 
			ifTrue: [ 
				coralArgs := coralArgs at: #coralArgs.
				coralArgsCollection := (coralArgs first subStrings: '"') reject: [ :each | each = String space ].
				currentArgs := SmalltalkImage current extractMinusParametersFrom: coralArgsCollection.
			]
			ifFalse: [ currentArgs := Dictionary new ]	
	].

	^ currentArgs deepCopy
	! !

!CoralScriptWriting class methodsFor: 'arguments' stamp: 'AdrienBarreau 10/8/2010 17:47'!
getAllArgumentsWithoutMinus
	^ self getAllArguments at: #*! !

!CoralScriptWriting class methodsFor: 'arguments' stamp: 'AdrienBarreau 10/8/2010 17:47'!
getAllArgumentsWithoutMinusButScriptName
	^ self getAllArgumentsWithoutMinus allButFirst! !

!CoralScriptWriting class methodsFor: 'arguments' stamp: 'AdrienBarreau 5/16/2011 16:14'!
getArgumentAt: aPosition
	^ coralArgsCollection at: aPosition
	! !

!CoralScriptWriting class methodsFor: 'arguments' stamp: 'AdrienBarreau 5/16/2011 16:14'!
getArgumentsNumber
	^ coralArgsCollection size
	! !

!CoralScriptWriting class methodsFor: 'arguments' stamp: 'AdrienBarreau 10/8/2010 17:47'!
getScriptName
	^ self getAllArgumentsWithoutMinus first! !

!CoralScriptWriting class methodsFor: 'arguments' stamp: 'AdrienBarreau 5/16/2011 17:29'!
hasOption: aString
	^ self getAllArguments keys includes: aString! !

!CoralScriptWriting class methodsFor: 'arguments' stamp: 'AdrienBarreau 10/8/2010 17:36'!
resetArguments 
	currentArgs := nil! !

Object subclass: #ScriptInterpreter
	instanceVariableNames: 'nodes results'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

ScriptInterpreter class
	instanceVariableNames: 'fileName'!

!ScriptInterpreter commentStamp: 'DamienPollet 7/28/2011 16:11' prior: 0!
A ScriptInterpreter is responsible of evaluating a Coral script.!

ScriptInterpreter class
	instanceVariableNames: 'fileName'!

!ScriptInterpreter class methodsFor: 'script interpreter' stamp: 'StephaneDucasse 12/8/2009 18:24'!
parse: aStream
		
	^ PPCoralParser parse: aStream! !

!ScriptInterpreter class methodsFor: 'old' stamp: 'OlivierAuverlot 11/23/2010 21:56'!
startUp

	"Smalltalk addToStartUpList: self"
	| script |
	self halt.
	script := ((SmalltalkImage current getSystemAttribute: 2) ifNil:['']) convertFromSystemString.
	script isEmpty ifFalse:[
		[ScriptInterpreter parse: (FileStream readOnlyFileNamed: script)] 
			on: Exception
			do: [ :ex | 
				(ex isKindOf: InMidstOfFileinNotification) 
					ifTrue:[ ex resume: false ]
					ifFalse: [
				Smalltalk
					logError: ex printString
					inContext: thisContext
					to: 'CoralDebug.log'.
				Console printNl: ex printString]].
		Console printNl: ''.
		Smalltalk quitPrimitive]! !

Error subclass: #CLIInvalidSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral'!

!PPPredicateObjectParser class methodsFor: '*coral-instance creation' stamp: 'DamienPollet 8/4/2011 12:39'!
matching: elementParser message: aString
	^ self
		on: [ :each | elementParser matches: each ]
		message: aString! !
CoralREADME initialize!
CoralScriptLoader initialize!
